diff -arcN emacs-18.55/lisp/bytecomp.el nemacs-3.3.2/lisp/bytecomp.el
*** emacs-18.55/lisp/bytecomp.el	Sun Mar 20 10:29:42 1988
--- nemacs-3.3.2/lisp/bytecomp.el	Wed Jun  6 03:15:37 1990
***************
*** 1,3 ****
--- 1,6 ----
+ ;;; 87.7.20  modified by M.Sato <masahiko@nttlab.NTT.junet>
+ ;;; 88.1.18  Nemacs Ver.2.0
+ 
  ;; Compilation of Lisp code into byte code.
  ;; Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 259,265 ****
  			 (looking-at "\"")
  			 (progn (forward-char 1)
  				(insert "\\\n"))))))))
!       (let ((vms-stmlf-recfm t))
  	(write-region 1 (point-max)
  		      (concat (file-name-sans-versions filename) "c")))
        (kill-buffer (current-buffer))
--- 262,272 ----
  			 (looking-at "\"")
  			 (progn (forward-char 1)
  				(insert "\\\n"))))))))
!  ;;; patch by M.Sato  87.7.20
!  ;;;  (let ((vms-stmlf-recfm t))
!       (let ((vms-stmlf-recfm t)
! 	    (kanji-flag nil))
!  ;;; end of patch
  	(write-region 1 (point-max)
  		      (concat (file-name-sans-versions filename) "c")))
        (kill-buffer (current-buffer))
diff -arcN emacs-18.55/lisp/dabbrev.el nemacs-3.3.2/lisp/dabbrev.el
*** emacs-18.55/lisp/dabbrev.el	Wed Dec  9 08:18:02 1987
--- nemacs-3.3.2/lisp/dabbrev.el	Wed Jun  6 03:15:41 1990
***************
*** 1,3 ****
--- 1,5 ----
+ ;;; 89.9.21  modified for Nemacs Ver.3.2 by K.Handa
+ 
  ;; Dynamic abbreviation package for GNU Emacs.
  ;; Copyright (C) 1985, 1986 Free Software Foundation, Inc.
  
***************
*** 115,121 ****
  	(setq last-dabbrevs-expansion-location nil)
  	(setq last-dabbrev-table nil))  	; Clear table of things seen.
  
!       (setq pattern (concat "\\b" (regexp-quote abbrev) "\\(\\sw\\|\\s_\\)+"))
        ;; Try looking backward unless inhibited.
        (if (>= which 0)
  	  (progn 
--- 117,125 ----
  	(setq last-dabbrevs-expansion-location nil)
  	(setq last-dabbrev-table nil))  	; Clear table of things seen.
  
!       ;;; patch by K.Handa  89.9.21
!       (setq pattern (concat "\\b" (regexp-quote abbrev) "\\(\\w\\|\\s_\\)+"))
!       ;;; end of patch
        ;; Try looking backward unless inhibited.
        (if (>= which 0)
  	  (progn 
***************
*** 204,212 ****
  		       (re-search-forward pattern nil t))))
  
  	(if (not missing)
! 	    (progn
! 	      (setq result (buffer-substring (match-beginning 0)
! 					     (match-end 0)))
  	      (let* ((test last-dabbrev-table))
  		(while (and test
  			    (not
--- 208,226 ----
  		       (re-search-forward pattern nil t))))
  
  	(if (not missing)
! 	    ;;; patch by K.Handa  89.9.21
! 	    (let ((begin (match-beginning 0))
! 		  (end (match-end 0)))
! 	      (goto-char begin)
! 	      (save-excursion
! 		(if (re-search-forward "\\w\\b\\w" end t)
! 		    (progn
! 		      (goto-char (match-end 0))
! 		      (forward-char -1)
! 		      (setq end (point)))))
! 	      (goto-char (if reverse begin end))
! 	      (setq result (buffer-substring begin end))
! 	      ;;; end of patch
  	      (let* ((test last-dabbrev-table))
  		(while (and test
  			    (not
diff -arcN emacs-18.55/lisp/debug.el nemacs-3.3.2/lisp/debug.el
*** emacs-18.55/lisp/debug.el	Thu Dec 29 13:22:41 1988
--- nemacs-3.3.2/lisp/debug.el	Wed Jun  6 03:15:42 1990
***************
*** 1,3 ****
--- 1,10 ----
+ ;;; Ver.18.53   created by S. Tomura 89-Apr-14
+ ;;; Ver.18.52   created by S. Tomura 89-Mar-16
+ ;;; Ver.18.50   created by S. Tomura 88-Jun-11
+ ;;; Nemacs Ver.2.1  
+ ;;; Ver.18.47a  modified by S. Tomura 88-Mar-23
+ ;;;             kanji-flag is set to nil at debugger buffer
+ ;;;
  ;; Debuggers and related commands for Emacs
  ;; Copyright (C) 1985, 1986 Free Software Foundation, Inc.
  
***************
*** 52,57 ****
--- 59,67 ----
  	      (backtrace))
  	    (goto-char (point-min))
  	    (debugger-mode)
+ 	    ;;; patch by S. Tomura 89-Mar-17
+ 	    (setq kanji-flag nil)
+ 	    ;;; end of patch
  	    (delete-region (point)
  			   (progn
  			     (forward-sexp 8)
diff -arcN emacs-18.55/lisp/egg-keymap.el nemacs-3.3.2/lisp/egg-keymap.el
*** emacs-18.55/lisp/egg-keymap.el	Thu Jan  1 09:00:00 1970
--- nemacs-3.3.2/lisp/egg-keymap.el	Wed Jun  6 03:17:11 1990
***************
*** 0 ****
--- 1,161 ----
+ ;; Usefull key binding for Sun Function keys 
+ ;; Coded by Yutaka Ishikawa at ETL (yisikawa@etl.junet)
+ 
+ ;; This file is part of Egg on Nemacs (Japanese Environment)
+ 
+ ;; Egg is distributed in the forms of patches to GNU
+ ;; Emacs under the terms of the GNU EMACS GENERAL PUBLIC
+ ;; LICENSE which is distributed along with GNU Emacs by the
+ ;; Free Software Foundation.
+ 
+ ;; Egg is distributed in the hope that it will be useful,
+ ;; but WITHOUT ANY WARRANTY; without even the implied
+ ;; warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ ;; PURPOSE.  See the GNU EMACS GENERAL PUBLIC LICENSE for
+ ;; more details.
+ 
+ ;; You should have received a copy of the GNU EMACS GENERAL
+ ;; PUBLIC LICENSE along with Nemacs; see the file COPYING.
+ ;; If not, write to the Free Software Foundation, 675 Mass
+ ;; Ave, Cambridge, MA 02139, USA.
+ 
+ ;;
+ 
+ ;;
+ ;; Table of Function key codes:
+ ;;
+ ;;;		x11term/sun	x11term/others	xterm/all
+ ;;;
+ ;;; XK_L1:	"\e[192z"
+ ;;; XK_L2:	"\e[193z"
+ ;;; XK_L3:	"\e[194z"
+ ;;; XK_L4:	"\e[195z"
+ ;;; XK_L5:	"\e[196z"
+ ;;; XK_L6:	"\e[197z"
+ ;;; XK_L7:	"\e[198z"
+ ;;; XK_L8:	"\e[199z"
+ ;;; XK_L9:	"\e[200z"
+ ;;; XK_L10:	"\e[201z"
+ ;;; XK_R1:	"\e[208z"
+ ;;; XK_R2:	"\e[209z"
+ ;;; XK_R3:	"\e[210z"
+ ;;; XK_R4:	"\e[211z"
+ ;;; XK_R5:	"\e[212z"
+ ;;; XK_R6:	"\e[213z"
+ ;;; XK_R7:	"\e[214z"
+ ;;; XK_R8:	"\e[215z"
+ ;;; XK_R9:	"\e[216z"
+ ;;; XK_R10:	"\e[217z"
+ ;;; XK_R11:	"\e[218z"
+ ;;; XK_R12:	"\e[219z"
+ ;;; XK_R13:	"\e[220z"
+ ;;; XK_R14:	"\e[221z"
+ ;;; XK_R15:	"\e[222z"
+ ;;;
+ ;;; XK_Break:	"\e[223z" /* Sun3 "Alternate" key */
+ ;;;
+ ;;; XK_F1:	"\e[224z"	"\e[11~"	"\e[11~"
+ ;;; XK_F2:	"\e[225z"	"\e[12~"	"\e[12~"
+ ;;; XK_F3:	"\e[226z"	"\e[13~"	"\e[13~"
+ ;;; XK_F4:	"\e[227z"	"\e[14~"	"\e[14~"
+ ;;; XK_F5:	"\e[228z"	"\e[15~"	"\e[15~"
+ ;;; XK_F6:	"\e[229z"	"\e[17~"	"\e[17~"
+ ;;; XK_F7:	"\e[230z"	"\e[18~"	"\e[18~"
+ ;;; XK_F8:	"\e[231z"	"\e[19~"	"\e[19~"
+ ;;; XK_F9:	"\e[232z"	"\e[20~"	"\e[20~"
+ ;;;
+ ;;; XK_F10:			"\e[21~"	"\e[21~"
+ ;;; XK_F11:			"\e[23~"	"\e[23~"
+ ;;; XK_F12:			"\e[24~"	"\e[24~"
+ ;;; XK_F13:			"\e[25~"	"\e[25~"
+ ;;; XK_F14:			"\e[26~"	"\e[26~"
+ ;;; XK_F15:			"\e[28~"	"\e[28~"
+ ;;; XK_Help:			"\e[28~"	"\e[28~"
+ ;;; XK_F16:			"\e[29~"	"\e[29~"
+ ;;; XK_Menu:			"\e[29~"	"\e[29~"
+ ;;; XK_F17:			"\e[31~"	"\e[31~"
+ ;;; XK_F18:			"\e[32~"	"\e[32~"
+ ;;; XK_F19:			"\e[33~"	"\e[33~"
+ ;;; XK_F20:			"\e[34~"	"\e[34~"
+ ;;;	
+ ;;; XK_Find :			"\e[1~"		"\e[1~"
+ ;;; XK_Insert:			"\e[2~"		"\e[2~"
+ ;;; XK_Delete:			"\e[3~"		"\e[3~"
+ ;;; XK_Select:			"\e[4~"		"\e[4~"
+ ;;; XK_Prior:			"\e[5~"		"\e[5~"
+ ;;; XK_Next:			"\e[6~"		"\e[6~"
+ ;;; default:	"\e[-1z"	"\e[-1~"
+ ;;;
+ ;;; XK_Left:	"\C-b"		"\C-b"		"\eOC"(XK_R12)
+ ;;; XK_Right:	"\C-f"		"\C-f"		"\eOD"(XK_R10)
+ ;;; XK_Up:	"\C-p"		"\C-p"		"\eOA"(XK_R8)
+ ;;; XK_Down:	"\C-n"		"\C-n"		"\eOB"(XK_R10)
+ ;;;
+ ;;;
+ 
+ 
+ (defvar sun-rkeymap (make-keymap))
+ (fset 'sun-rprefix sun-rkeymap)
+ 
+ ;;;
+ ;;; Key bindings for X11 terminals(x11term)
+ ;;;
+ 
+ (define-key global-map "\eO" 'sun-rprefix)
+ (define-key sun-rkeymap "A" 'previous-line)
+ (define-key sun-rkeymap "B" 'next-line)
+ (define-key sun-rkeymap "C" 'forward-char)
+ (define-key sun-rkeymap "D" 'backward-char)
+ 
+ (defvar sun-fkeymap (make-keymap))
+ (fset 'sun-fprefix sun-fkeymap)
+ ;;;
+ ;;; Key bindings for non Sun X11 terminal(x11term and [kx]term)
+ ;;;
+ (define-key global-map "\e[" 'sun-fprefix)
+ (define-key sun-fkeymap "["   'backward-paragraph) ; old "\e[" assignment
+ (define-key sun-fkeymap "11~" 'change-fileio-code)	; F1
+ (define-key sun-fkeymap "12~" 'edit-dict-item)	        ; F2
+ (define-key sun-fkeymap "13~" 'jis-code-input)   	; F3
+ (define-key sun-fkeymap "14~" 'toroku-region)		; F4
+ (define-key sun-fkeymap "15~" 'zenkaku-region)		; F5
+ (define-key sun-fkeymap "17~" 'hankaku-region)		; F6
+ (define-key sun-fkeymap "18~" 'katakana-region)		; F7
+ (define-key sun-fkeymap "19~" 'hiragana-region)		; F8
+ (define-key sun-fkeymap "20~" 'henkan-region)		; F9
+ 
+ (define-key sun-fkeymap "23~" 'insert-buffer)		; F11 or         L1
+ (define-key sun-fkeymap "24~" 'insert-file)		; F12 or         L2
+ (define-key sun-fkeymap "25~" 'eval-region)		; F13 or         L3
+ (define-key sun-fkeymap "26~" 'eval-current-buffer)	; F14 or         L4
+ (define-key sun-fkeymap "28~" 'enlarge-window)		; F15 or Help or L5
+ (define-key sun-fkeymap "29~" 'shrink-window)		; F16 or Menu or L6
+ (define-key sun-fkeymap "31~" 'revert-buffer)		; F17 or         L7
+ (define-key sun-fkeymap "32~" 'revert-buffer)		; F18 or         L8
+ (define-key sun-fkeymap "33~" 'beginning-of-buffer)	; F19 or         L9
+ (define-key sun-fkeymap "34~" 'end-of-buffer)		; F20 or         L10
+ 
+ ;;;
+ ;;; Key bindings for Sun X11 terminals(x11term)
+ ;;;
+ 
+ (define-key sun-fkeymap "192z" 'insert-buffer)		; L1
+ (define-key sun-fkeymap "193z" 'insert-file)		; L2
+ (define-key sun-fkeymap "194z" 'eval-region)		; L3
+ (define-key sun-fkeymap "195z" 'eval-current-buffer)	; L4
+ (define-key sun-fkeymap "196z" 'enlarge-window)		; L5
+ (define-key sun-fkeymap "197z" 'shrink-window)		; L6
+ (define-key sun-fkeymap "198z" 'revert-buffer)		; L7
+ (define-key sun-fkeymap "199z" 'revert-buffer)		; L8
+ (define-key sun-fkeymap "200z" 'beginning-of-buffer)	; L9
+ (define-key sun-fkeymap "201z" 'end-of-buffer)		; L10
+ 
+ (define-key sun-fkeymap "224z" 'change-fileio-code)	; F1
+ (define-key sun-fkeymap "225z" 'edit-dict-item)	        ; F2
+ (define-key sun-fkeymap "226z" 'jis-code-input)   	; F3
+ (define-key sun-fkeymap "227z" 'toroku-region)		; F4
+ (define-key sun-fkeymap "228z" 'zenkaku-region)		; F5
+ (define-key sun-fkeymap "229z" 'hankaku-region)		; F6
+ (define-key sun-fkeymap "230z" 'katakana-region)	; F7
+ (define-key sun-fkeymap "231z" 'hiragana-region)	; F8
+ (define-key sun-fkeymap "232z" 'henkan-region)		; F9
diff -arcN emacs-18.55/lisp/egg-rk.el nemacs-3.3.2/lisp/egg-rk.el
*** emacs-18.55/lisp/egg-rk.el	Thu Jan  1 09:00:00 1970
--- nemacs-3.3.2/lisp/egg-rk.el	Wed Jun  6 03:17:11 1990
***************
*** 0 ****
--- 1,508 ----
+ ;; Basic Roma-to-Kana Translation Table for Egg
+ ;; Coded by S.Tomura, Electrotechnical Lab. (tomura@etl.go.jp)
+ 
+ ;; This file is part of Egg on Nemacs (Japanese Environment)
+ 
+ ;; Egg is distributed in the forms of patches to GNU
+ ;; Emacs under the terms of the GNU EMACS GENERAL PUBLIC
+ ;; LICENSE which is distributed along with GNU Emacs by the
+ ;; Free Software Foundation.
+ 
+ ;; Egg is distributed in the hope that it will be useful,
+ ;; but WITHOUT ANY WARRANTY; without even the implied
+ ;; warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ ;; PURPOSE.  See the GNU EMACS GENERAL PUBLIC LICENSE for
+ ;; more details.
+ 
+ ;; You should have received a copy of the GNU EMACS GENERAL
+ ;; PUBLIC LICENSE along with Nemacs; see the file COPYING.
+ ;; If not, write to the Free Software Foundation, 675 Mass
+ ;; Ave, Cambridge, MA 02139, USA.
+ 
+ ;;; 90.3.2   modified for Nemacs Ver.3.3.1
+ ;;;	by jiro@math.keio.ac.jp (TANAKA Jiro)
+ ;;;     proposal of keybinding for JIS symbols
+ 
+ (define-egg-mode "roma-kana" t)
+ 
+ (defvar aa '("k" "s" "t" "h" "y" "r" "w" "g" "z" "d" "b"
+ 		 "p" "c" "f" "j" "v"))
+ (defrule  '(aa aa) "¤Ã" '(aa))
+ 
+ (defrule "tch"  "¤Ã" "ch")
+ 
+ (defvar q1 '("b" "m" "p"))
+ 
+ (defrule '("m" q1) "¤ó" '(q1))
+ 
+ (defrule "n" "¤ó")
+ (defrule "N" "¤ó")
+ 
+ (defvar enable-double-n-syntax nil "*Enable ""nn"" input for ""¤ó"" ")
+ 
+ (if enable-double-n-syntax 
+     (defrule "nn" "¤ó"))
+ 
+ (defrule "n'" "¤ó")
+ 
+ (defvar small '("x") )
+ 
+ (defrule '(small "a") "¤¡")
+ (defrule '(small "i") "¤£")
+ (defrule '(small "u") "¤¥")
+ (defrule '(small "e") "¤§")
+ (defrule '(small "o") "¤©")
+ (defrule '(small "ya") "¤ã")
+ (defrule '(small "yu") "¤å")
+ (defrule '(small "yo") "¤ç")
+ (defrule '(small "tu") "¤Ã")
+ (defrule '(small "tsu") "¤Ã")
+ (defrule '(small "wa") "¤î")
+ 
+ 
+ (defrule   "a"    "¤¢")
+ (defrule   "i"    "¤¤")
+ (defrule   "u"    "¤¦")
+ (defrule   "e"    "¤¨")
+ (defrule   "o"    "¤ª")
+ (defrule   "ka"   "¤«")
+ (defrule   "ki"   "¤­")
+ (defrule   "ku"   "¤¯")
+ (defrule   "ke"   "¤±")
+ (defrule   "ko"   "¤³")
+ (defrule   "kya"  "¤­¤ã")
+ (defrule   "kyu"  "¤­¤å")
+ (defrule   "kye"  "¤­¤§")
+ (defrule   "kyo"  "¤­¤ç")
+ (defrule   "sa"   "¤µ")
+ (defrule   "si"   "¤·")
+ (defrule   "su"   "¤¹")
+ (defrule   "se"   "¤»")
+ (defrule   "so"   "¤½")
+ (defrule   "sya"  "¤·¤ã")
+ (defrule   "syu"  "¤·¤å")
+ (defrule   "sye"  "¤·¤§")
+ (defrule   "syo"  "¤·¤ç")
+ (defrule   "sha"  "¤·¤ã")
+ (defrule   "shi"  "¤·")
+ (defrule   "shu"  "¤·¤å")
+ (defrule   "she"  "¤·¤§")
+ (defrule   "sho"  "¤·¤ç")
+ (defrule   "ta"   "¤¿")
+ (defrule   "ti"   "¤Á")
+ (defrule   "tu"   "¤Ä")
+ (defrule   "te"   "¤Æ")
+ (defrule   "to"   "¤È")
+ (defrule   "tya"  "¤Á¤ã")
+ (defrule   "tyi"  "¤Æ¤£")
+ (defrule   "tyu"  "¤Á¤å")
+ (defrule   "tye"  "¤Á¤§")
+ (defrule   "tyo"  "¤Á¤ç")
+ (defrule   "tsu"  "¤Ä")
+ (defrule   "cha"  "¤Á¤ã")
+ (defrule   "chi"  "¤Á")
+ (defrule   "chu"  "¤Á¤å")
+ (defrule   "che"  "¤Á¤§")
+ (defrule   "cho"  "¤Á¤ç")
+ (defrule   "na"   "¤Ê")
+ (defrule   "ni"   "¤Ë")
+ (defrule   "nu"   "¤Ì")
+ (defrule   "ne"   "¤Í")
+ (defrule   "no"   "¤Î")
+ (defrule   "nya"  "¤Ë¤ã")
+ (defrule   "nyu"  "¤Ë¤å")
+ (defrule   "nye"  "¤Ë¤§")
+ (defrule   "nyo"  "¤Ë¤ç")
+ (defrule   "ha"   "¤Ï")
+ (defrule   "hi"   "¤Ò")
+ (defrule   "hu"   "¤Õ")
+ (defrule   "he"   "¤Ø")
+ (defrule   "ho"   "¤Û")
+ (defrule   "hya"  "¤Ò¤ã")
+ (defrule   "hyu"  "¤Ò¤å")
+ (defrule   "hye"  "¤Ò¤§")
+ (defrule   "hyo"  "¤Ò¤ç")
+ (defrule   "fa"   "¤Õ¤¡")
+ (defrule   "fi"   "¤Õ¤£")
+ (defrule   "fu"   "¤Õ")
+ (defrule   "fe"   "¤Õ¤§")
+ (defrule   "fo"   "¤Õ¤©")
+ (defrule   "ma"   "¤Þ")
+ (defrule   "mi"   "¤ß")
+ (defrule   "mu"   "¤à")
+ (defrule   "me"   "¤á")
+ (defrule   "mo"   "¤â")
+ (defrule   "mya"  "¤ß¤ã")
+ (defrule   "myu"  "¤ß¤å")
+ (defrule   "mye"  "¤ß¤§")
+ (defrule   "myo"  "¤ß¤ç")
+ (defrule   "ya"   "¤ä")
+ (defrule   "yi"   "¤¤")
+ (defrule   "yu"   "¤æ")
+ (defrule   "ye"   "¤¤¤§")
+ (defrule   "yo"   "¤è")
+ (defrule   "ra"   "¤é")
+ (defrule   "ri"   "¤ê")
+ (defrule   "ru"   "¤ë")
+ (defrule   "re"   "¤ì")
+ (defrule   "ro"   "¤í")
+ (defrule   "la"   "¤é")
+ (defrule   "li"   "¤ê")
+ (defrule   "lu"   "¤ë")
+ (defrule   "le"   "¤ì")
+ (defrule   "lo"   "¤í")
+ (defrule   "rya"  "¤ê¤ã")
+ (defrule   "ryu"  "¤ê¤å")
+ (defrule   "rye"  "¤ê¤§")
+ (defrule   "ryo"  "¤ê¤ç")
+ (defrule   "lya"  "¤ê¤ã")
+ (defrule   "lyu"  "¤ê¤å")
+ (defrule   "lye"  "¤ê¤§")
+ (defrule   "lyo"  "¤ê¤ç")
+ (defrule   "wa"   "¤ï")
+ (defrule   "wi"   "¤ð")
+ (defrule   "wu"   "¤¦")
+ (defrule   "we"   "¤ñ")
+ (defrule   "wo"   "¤ò")
+ (defrule   "ga"   "¤¬")
+ (defrule   "gi"   "¤®")
+ (defrule   "gu"   "¤°")
+ (defrule   "ge"   "¤²")
+ (defrule   "go"   "¤´")
+ (defrule   "gya"  "¤®¤ã")
+ (defrule   "gyu"  "¤®¤å")
+ (defrule   "gye"  "¤®¤§")
+ (defrule   "gyo"  "¤®¤ç")
+ (defrule   "za"   "¤¶")
+ (defrule   "zi"   "¤¸")
+ (defrule   "zu"   "¤º")
+ (defrule   "ze"   "¤¼")
+ (defrule   "zo"   "¤¾")
+ (defrule   "zya"  "¤¸¤ã")
+ (defrule   "zyu"  "¤¸¤å")
+ (defrule   "zye"  "¤¸¤§")
+ (defrule   "zyo"  "¤¸¤ç")
+ (defrule   "ja"   "¤¸¤ã")
+ (defrule   "ji"   "¤¸")
+ (defrule   "ju"   "¤¸¤å")
+ (defrule   "je"   "¤¸¤§")
+ (defrule   "jo"   "¤¸¤ç")
+ (defrule   "da"   "¤À")
+ (defrule   "di"   "¤Â")
+ (defrule   "du"   "¤Å")
+ (defrule   "de"   "¤Ç")
+ (defrule   "do"   "¤É")
+ (defrule   "dya"  "¤Â¤ã")
+ (defrule   "dyi"  "¤Ç¤£")
+ (defrule   "dyu"  "¤Â¤å")
+ (defrule   "dye"  "¤Â¤§")
+ (defrule   "dyo"  "¤Â¤ç")
+ (defrule   "ba"   "¤Ð")
+ (defrule   "bi"   "¤Ó")
+ (defrule   "bu"   "¤Ö")
+ (defrule   "be"   "¤Ù")
+ (defrule   "bo"   "¤Ü")
+ (defrule   "va"   "¥ô¤¡")
+ (defrule   "vi"   "¥ô¤£")
+ (defrule   "vu"   "¥ô")
+ (defrule   "ve"   "¥ô¤§")
+ (defrule   "vo"   "¥ô¤©")
+ (defrule   "bya"  "¤Ó¤ã")
+ (defrule   "byu"  "¤Ó¤å")
+ (defrule   "bye"  "¤Ó¤§")
+ (defrule   "byo"  "¤Ó¤ç")
+ (defrule   "pa"   "¤Ñ")
+ (defrule   "pi"   "¤Ô")
+ (defrule   "pu"   "¤×")
+ (defrule   "pe"   "¤Ú")
+ (defrule   "po"   "¤Ý")
+ (defrule   "pya"  "¤Ô¤ã")
+ (defrule   "pyu"  "¤Ô¤å")
+ (defrule   "pye"  "¤Ô¤§")
+ (defrule   "pyo"  "¤Ô¤ç")
+ (defrule   "kwa"  "¤¯¤î")
+ (defrule   "kwi"  "¤¯¤£")
+ (defrule   "kwu"  "¤¯")
+ (defrule   "kwe"  "¤¯¤§")
+ (defrule   "kwo"  "¤¯¤©")
+ (defrule   "gwa"  "¤°¤î")
+ (defrule   "gwi"  "¤°¤£")
+ (defrule   "gwu"  "¤°")
+ (defrule   "gwe"  "¤°¤§")
+ (defrule   "gwo"  "¤°¤©")
+ (defrule   "tsa"  "¤Ä¤¡")
+ (defrule   "tsi"  "¤Ä¤£")
+ (defrule   "tse"  "¤Ä¤§")
+ (defrule   "tso"  "¤Ä¤©")
+ (defrule   "xka"  "¥õ")
+ (defrule   "xke"  "¥ö")
+ (defrule   "xti"  "¤Æ¤£")
+ (defrule   "xdi"  "¤Ç¤£")
+ (defrule   "xdu"  "¤É¤¥")
+ (defrule   "xde"  "¤Ç¤§")
+ (defrule   "xdo"  "¤É¤©")
+ (defrule   "xwa"  "¤î")
+ (defrule   "xwi"  "¤¦¤£")
+ (defrule   "xwe"  "¤¦¤§")
+ (defrule   "xwo"  "¤¦¤©")
+ 
+ ;;; Zenkaku Symbols
+ 
+ (defrule   "1"   "£±")
+ (defrule   "2"   "£²")
+ (defrule   "3"   "£³")
+ (defrule   "4"   "£´")
+ (defrule   "5"   "£µ")
+ (defrule   "6"   "£¶")
+ (defrule   "7"   "£·")
+ (defrule   "8"   "£¸")
+ (defrule   "9"   "£¹")
+ (defrule   "0"   "£°")
+ 
+ (defrule   " "   "¡¡")
+ (defrule   "!"   "¡ª")
+ (defrule   "@"   "¡÷")
+ (defrule   "#"   "¡ô")
+ (defrule   "$"   "¡ð")
+ (defrule   "%"   "¡ó")
+ (defrule   "^"   "¡°")
+ (defrule   "&"   "¡õ")
+ (defrule   "*"   "¡ö")
+ (defrule   "("   "¡Ê")
+ (defrule   ")"   "¡Ë")
+ (defrule   "-"   "¡¼") ;;; JIS 213c  ;;;(defrule   "-"   "¡Ý")
+ (defrule   "="   "¡á")
+ (defrule   "`"   "¡®")
+ (defrule   "\\"  "¡ï")
+ (defrule   "|"   "¡Ã")
+ (defrule   "_"   "¡²")
+ (defrule   "+"   "¡Ü")
+ (defrule   "~"   "¡±")
+ (defrule   "["    "¡Ö")  ;;(defrule   "["   "¡Î")
+ (defrule   "]"    "¡×")  ;;(defrule   "]"   "¡Ï")
+ (defrule   "{"   "¡Ð")
+ (defrule   "}"   "¡Ñ")
+ (defrule   ":"   "¡§")
+ (defrule   ";"   "¡¨")
+ (defrule   "\""  "¡É")
+ (defrule   "'"   "¡Ç")
+ (defrule   "<"   "¡ã")
+ (defrule   ">"   "¡ä")
+ (defrule   "?"   "¡©")
+ (defrule   "/"   "¡¿")
+ (defrule   ","   "¡¢")  ;;(defrule   ","   "¡¤")
+ (defrule   "."   "¡£")  ;;(defrule   "."   "¡¥")
+ 
+ 
+ ;;; Escape character to Zenkaku inputs
+ 
+ (defvar zenkaku-escape "Z")
+ 
+ ;;; Escape character to Hankaku inputs
+ 
+ (defvar hankaku-escape "~")
+ ;;;
+ ;;; Zenkaku inputs
+ ;;;
+ 
+ (defrule '(zenkaku-escape "0") "£°")
+ (defrule '(zenkaku-escape "1") "£±")
+ (defrule '(zenkaku-escape "2") "£²")
+ (defrule '(zenkaku-escape "3") "£³")
+ (defrule '(zenkaku-escape "4") "£´")
+ (defrule '(zenkaku-escape "5") "£µ")
+ (defrule '(zenkaku-escape "6") "£¶")
+ (defrule '(zenkaku-escape "7") "£·")
+ (defrule '(zenkaku-escape "8") "£¸")
+ (defrule '(zenkaku-escape "9") "£¹")
+ 
+ (defrule '(zenkaku-escape "A") "£Á")
+ (defrule '(zenkaku-escape "B") "£Â")
+ (defrule '(zenkaku-escape "C") "£Ã")
+ (defrule '(zenkaku-escape "D") "£Ä")
+ (defrule '(zenkaku-escape "E") "£Å")
+ (defrule '(zenkaku-escape "F") "£Æ")
+ (defrule '(zenkaku-escape "G") "£Ç")
+ (defrule '(zenkaku-escape "H") "£È")
+ (defrule '(zenkaku-escape "I") "£É")
+ (defrule '(zenkaku-escape "J") "£Ê")
+ (defrule '(zenkaku-escape "K") "£Ë")
+ (defrule '(zenkaku-escape "L") "£Ì")
+ (defrule '(zenkaku-escape "M") "£Í")
+ (defrule '(zenkaku-escape "N") "£Î")
+ (defrule '(zenkaku-escape "O") "£Ï")
+ (defrule '(zenkaku-escape "P") "£Ð")
+ (defrule '(zenkaku-escape "Q") "£Ñ")
+ (defrule '(zenkaku-escape "R") "£Ò")
+ (defrule '(zenkaku-escape "S") "£Ó")
+ (defrule '(zenkaku-escape "T") "£Ô")
+ (defrule '(zenkaku-escape "U") "£Õ")
+ (defrule '(zenkaku-escape "V") "£Ö")
+ (defrule '(zenkaku-escape "W") "£×")
+ (defrule '(zenkaku-escape "X") "£Ø")
+ (defrule '(zenkaku-escape "Y") "£Ù")
+ (defrule '(zenkaku-escape "Z") "£Ú")
+ 
+ (defrule '(zenkaku-escape "a") "£á")
+ (defrule '(zenkaku-escape "b") "£â")
+ (defrule '(zenkaku-escape "c") "£ã")
+ (defrule '(zenkaku-escape "d") "£ä")
+ (defrule '(zenkaku-escape "e") "£å")
+ (defrule '(zenkaku-escape "f") "£æ")
+ (defrule '(zenkaku-escape "g") "£ç")
+ (defrule '(zenkaku-escape "h") "£è")
+ (defrule '(zenkaku-escape "i") "£é")
+ (defrule '(zenkaku-escape "j") "£ê")
+ (defrule '(zenkaku-escape "k") "£ë")
+ (defrule '(zenkaku-escape "l") "£ì")
+ (defrule '(zenkaku-escape "m") "£í")
+ (defrule '(zenkaku-escape "n") "£î")
+ (defrule '(zenkaku-escape "o") "£ï")
+ (defrule '(zenkaku-escape "p") "£ð")
+ (defrule '(zenkaku-escape "q") "£ñ")
+ (defrule '(zenkaku-escape "r") "£ò")
+ (defrule '(zenkaku-escape "s") "£ó")
+ (defrule '(zenkaku-escape "t") "£ô")
+ (defrule '(zenkaku-escape "u") "£õ")
+ (defrule '(zenkaku-escape "v") "£ö")
+ (defrule '(zenkaku-escape "w") "£÷")
+ (defrule '(zenkaku-escape "x") "£ø")
+ (defrule '(zenkaku-escape "y") "£ù")
+ (defrule '(zenkaku-escape "z") "£ú")
+ 
+ (defrule '(zenkaku-escape " ")  "¡¡")
+ (defrule '(zenkaku-escape "!")  "¡ª")
+ (defrule '(zenkaku-escape "@")  "¡÷")
+ (defrule '(zenkaku-escape "#")  "¡ô")
+ (defrule '(zenkaku-escape "$")  "¡ð")
+ (defrule '(zenkaku-escape "%")  "¡ó")
+ (defrule '(zenkaku-escape "^")  "¡°")
+ (defrule '(zenkaku-escape "&")  "¡õ")
+ (defrule '(zenkaku-escape "*")  "¡ö")
+ (defrule '(zenkaku-escape "(")  "¡Ê")
+ (defrule '(zenkaku-escape ")")  "¡Ë")
+ (defrule '(zenkaku-escape "-")  "¡Ý")
+ (defrule '(zenkaku-escape "=")  "¡á")
+ (defrule '(zenkaku-escape "`")  "¡®")
+ (defrule '(zenkaku-escape "\\") "¡ï")
+ (defrule '(zenkaku-escape "|")  "¡Ã")
+ (defrule '(zenkaku-escape "_")  "¡²")
+ (defrule '(zenkaku-escape "+")  "¡Ü")
+ (defrule '(zenkaku-escape "~")  "¡±")
+ (defrule '(zenkaku-escape "[")  "¡Î")
+ (defrule '(zenkaku-escape "]")  "¡Ï")
+ (defrule '(zenkaku-escape "{")  "¡Ð")
+ (defrule '(zenkaku-escape "}")  "¡Ñ")
+ (defrule '(zenkaku-escape ":")  "¡§")
+ (defrule '(zenkaku-escape ";")  "¡¨")
+ (defrule '(zenkaku-escape "\"") "¡É")
+ (defrule '(zenkaku-escape "'")  "¡Ç")
+ (defrule '(zenkaku-escape "<")  "¡ã")
+ (defrule '(zenkaku-escape ">")  "¡ä")
+ (defrule '(zenkaku-escape "?")  "¡©")
+ (defrule '(zenkaku-escape "/")  "¡¿")
+ (defrule '(zenkaku-escape ",")  "¡¤")
+ (defrule '(zenkaku-escape ".")  "¡¥")
+ 
+ ;;;
+ ;;; Hankaku inputs
+ ;;;
+ 
+ ;;(defvar escd '("-" "," "." "/" ";" ":" "[" "\\" "]" "^" "~"))
+ ;;(defrule '("x" escd)  '(escd))
+ 
+ 
+ (defvar digit-characters 
+    '( "1"  "2"  "3"  "4" "5"  "6"  "7"  "8"  "9"  "0" ))
+ 
+ (defvar symbol-characters 
+    '( " "  "!"  "@"  "#"  "$"  "%"  "^"  "&"  "*"  "("  ")"
+       "-"  "="  "`"  "\\" "|"  "_"  "+"  "~" "["  "]"  "{"  "}"
+       ":"  ";"  "\"" "'"  "<"  ">"  "?"  "/"  ","  "." ))
+ 
+ (defvar downcase-alphabets 
+    '("a" "b" "c" "d" "e" "f" "g" "h" "i" "j" "k" "l" "m" "n"
+      "o" "p" "q" "r" "s" "t" "u" "v" "w" "x" "y" "z"))
+ 
+ (defvar upcase-alphabets
+    '("A" "B" "C" "D" "E" "F" "G" "H" "I" "J" "K" "L" "M" "N"
+      "O" "P" "Q" "R" "S" "T" "U" "V" "W" "X" "Y" "Z"))
+ 
+ (defrule '(hankaku-escape digit-characters)   '(digit-characters))
+ (defrule '(hankaku-escape symbol-characters)  '(symbol-characters))
+ (defrule '(hankaku-escape downcase-alphabets) '(downcase-alphabets))
+ (defrule '(hankaku-escape upcase-alphabets)   '(upcase-alphabets))
+ 
+ ;;(defvar upcase-escape   "X")
+ 
+ ;;(defrule '(upcase-escape digit-characters)     '(digit-characters))
+ ;;(defrule '(upcase-escape symbol-characters)    '(symbol-characters))
+ ;;(defrule '(upcase-escape upcase-alphabets)     '(upcase-alphabets))
+ 
+ ;;; Note: We cannot define
+ ;;; (defrule '(upcase-escape downcase-alphabets) '(upcase-alphabets))
+ ;;; We need association between them.
+ 
+ ;;;; Proposal:
+ ;;;; (defvar down-up-assoc '(("a" "A") ("b" "B")....))
+ ;;;; (defrule '((upcase-escape) (downcase-alpha))
+ ;;;;          '(downcase-alpha down-up-assoc))
+ ;;;;
+ 
+ ;;; proposal key bindings for JIS symbols
+ ;;; 90.3.2  by jiro@math.keio.ac.jp (TANAKA Jiro)
+ 
+ (defrule   "z1"   "¡û")	(defrule   "z!"   "¡ü")
+ (defrule   "z2"   "¢¦")	(defrule   "z@"   "¢§")
+ (defrule   "z3"   "¢¤")	(defrule   "z#"   "¢¥")
+ (defrule   "z4"   "¢¢")	(defrule   "z$"   "¢£")
+ (defrule   "z5"   "¡þ")	(defrule   "z%"   "¢¡")
+ (defrule   "z6"   "¡ù")	(defrule   "z^"   "¡ú")
+ (defrule   "z7"   "¡ý")	(defrule   "z&"   "¡ò")
+ (defrule   "z8"   "¡ñ")	(defrule   "z*"   "¡ß")
+ (defrule   "z9"   "¡é")	(defrule   "z("   "¡Ú")
+ (defrule   "z0"   "¡ê")	(defrule   "z)"   "¡Û")
+ (defrule   "z-"   "¡Á")	(defrule   "z_"   "¡è")	; z-
+ (defrule   "z="   "¡â")	(defrule   "z+"   "¡Þ")
+ (defrule   "z\\"  "¡À")	(defrule   "z|"   "¡Â")
+ (defrule   "z`"   "¡­")	(defrule   "z~"   "¡¯")
+ 
+ (defrule   "zq"   "¡Ô")	(defrule   "zQ"   "¡Ò")
+ (defrule   "zw"   "¡Õ")	(defrule   "zW"   "¡Ó")
+ ; e
+ (defrule   "zr"   "¡¹")	(defrule   "zR"   "¡¸")	; zr
+ (defrule   "zt"   "¡º")	(defrule   "zT"   "¡ø")
+ ; y u i o
+ (defrule   "zp"   "¢©")	(defrule   "zP"   "¢¬")	; zp
+ (defrule   "z["   "¡Ø")	(defrule   "z{"   "¡Ì")	; z[
+ (defrule   "z]"   "¡Ù")	(defrule   "z}"   "¡Í")	; z]
+ 
+ ; a
+ (defrule   "zs"   "¡³")	(defrule   "zS"   "¡´")
+ (defrule   "zd"   "¡µ")	(defrule   "zD"   "¡¶")
+ (defrule   "zf"   "¡·")	(defrule   "zF"   "¢ª")
+ (defrule   "zg"   "¡¾")	(defrule   "zG"   "¡½")
+ (defrule   "zh"   "¢«")
+ (defrule   "zj"   "¢­")
+ (defrule   "zk"   "¢¬")
+ (defrule   "zl"   "¢ª")
+ (defrule   "z;"   "¡«")	(defrule   "z:"   "¡¬")
+ (defrule   "z\'"  "¡Æ")	(defrule   "z\""  "¡È")
+ 
+ ; z
+ (defrule   "zx"   ":-")	(defrule   "zX"   ":-)")
+ (defrule   "zc"   "¡»")	(defrule   "zC"   "¡î")	; zc
+ (defrule   "zv"   "¢¨")	(defrule   "zV"   "¡à")
+ (defrule   "zb"   "¡ë")	(defrule   "zB"   "¢«")
+ (defrule   "zn"   "¡ì")	(defrule   "zN"   "¢­")
+ (defrule   "zm"   "¡í")	(defrule   "zM"   "¢®")
+ (defrule   "z,"   "¡Å")	(defrule   "z<"   "¡å")
+ (defrule   "z."   "¡Ä")	(defrule   "z>"   "¡æ")	; z.
+ (defrule   "z/"   "¡¦")	(defrule   "z?"   "¡ç")	; z/
+ 
+ ;;; Commented out by K.Handa.  Already defined in a different way.
+ ;(defrule   "va"   "¥ô¥¡")
+ ;(defrule   "vi"   "¥ô¥£")
+ ;(defrule   "vu"   "¥ô")
+ ;(defrule   "ve"   "¥ô¥§")
+ ;(defrule   "vo"   "¥ô¥©")
